// Author: Ivan Kazmenko (gassa@mail.ru)
module common;
import obj;

import allegro5.allegro;
import allegro5.allegro_audio;
import allegro5.allegro_font;

immutable int maxX = 1024;
immutable int maxY =  768;
immutable real fps = 60.0;
immutable int commonFreq = 44_100;

ALLEGRO_DISPLAY * display;
ALLEGRO_EVENT_QUEUE * eventQueue;
ALLEGRO_TIMER * drawTimer;
ALLEGRO_FONT * textFont;
ALLEGRO_FONT * buttonFont;
ALLEGRO_FONT * captionFont;

ALLEGRO_VOICE * voice;
ALLEGRO_MIXER * mixer;

auto toAllegroUstr (const char [] s)
{
	auto tempUstrInfo = new ALLEGRO_USTR_INFO;
	return al_ref_buffer (tempUstrInfo, s.ptr, s.length);
}

Obj [] rootStack;
Obj screenRoot;
Obj cursorRoot;
Obj menu;
