// Author: Ivan Kazmenko (gassa@mail.ru)
module board;
import obj;
import rect;
import slot;
import tile;

import allegro5.allegro;

import std.random;

class Board : Rect
{
	Slot [] [] slot;

	this (Obj parent_, int relX_, int relY_, int w_, int h_, int radius_,
	    ALLEGRO_COLOR fillColor_, int pw, int ph, int tw, int th,
	    string [] [] levelMap, Tile [] [] tile)
	{
		super (parent_, relX_, relY_, w_, h_, radius_, fillColor_);
		slot = new Slot [] [] (ph, pw);
		foreach (row; 0..ph)
		{
			foreach (col; 0..pw)
			{
				slot[row][col] = new Slot (this,
				    col * th, row * tw, th, tw, 10,
				    al_map_rgb_f (0.1, 0.2, 0.3),
				    5, al_map_rgb_f (0.3, 0.6, 0.9),
				    al_map_rgba_f (0.2, 0.4, 0.6, 0.8),
				    tile[row][col]);
			}
		}
	}
}
